/*
 * OSM NB API featuring ETSI NFV SOL005
 * This is Open Source MANO Northbound API featuring ETSI NFV SOL005. For more information on OSM, you can visit [http://osm.etsi.org](http://osm.etsi.org). You can send us your comments and questions to OSM_TECH@list.etsi.org or join the [OpenSourceMANO Slack Workplace](https://join.slack.com/t/opensourcemano/shared_invite/enQtMzQ3MzYzNTQ0NDIyLWVkNTE4ZjZjNWI0ZTQyN2VhOTI1MjViMzU1NWYwMWM3ODI4NTQyY2VlODA2ZjczMWIyYTFkZWNiZmFkM2M2ZDk) 
 *
 * OpenAPI spec version: 1.0.0
 * Contact: OSM_TECH@list.etsi.org
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package it.nextworks.lcm.nfvo.osm.rest.model;

import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.v3.oas.annotations.media.Schema;

import java.io.IOException;
import java.util.Objects;

/**
 * ScaleNsRequestScaleVnfData
 */

@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2022-03-04T13:48:18.253Z[GMT]")
public class ScaleNsRequestScaleVnfData {
  /**
   * Gets or Sets scaleVnfType
   */
  @JsonAdapter(ScaleVnfTypeEnum.Adapter.class)
  public enum ScaleVnfTypeEnum {
    IN("SCALE_IN"),
    OUT("SCALE_OUT");

    private String value;

    ScaleVnfTypeEnum(String value) {
      this.value = value;
    }
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
    public static ScaleVnfTypeEnum fromValue(String input) {
      for (ScaleVnfTypeEnum b : ScaleVnfTypeEnum.values()) {
        if (b.value.equals(input)) {
          return b;
        }
      }
      return null;
    }
    public static class Adapter extends TypeAdapter<ScaleVnfTypeEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final ScaleVnfTypeEnum enumeration) throws IOException {
        jsonWriter.value(String.valueOf(enumeration.getValue()));
      }

      @Override
      public ScaleVnfTypeEnum read(final JsonReader jsonReader) throws IOException {
        Object value = jsonReader.nextString();
        return ScaleVnfTypeEnum.fromValue((String)(value));
      }
    }
  }  @SerializedName("scaleVnfType")
  private ScaleVnfTypeEnum scaleVnfType = null;

  @SerializedName("scaleByStepData")
  private ScaleNsRequestScaleVnfDataScaleByStepData scaleByStepData = null;

  public ScaleNsRequestScaleVnfData scaleVnfType(ScaleVnfTypeEnum scaleVnfType) {
    this.scaleVnfType = scaleVnfType;
    return this;
  }

   /**
   * Get scaleVnfType
   * @return scaleVnfType
  **/
  @Schema(required = true, description = "")
  public ScaleVnfTypeEnum getScaleVnfType() {
    return scaleVnfType;
  }

  public void setScaleVnfType(ScaleVnfTypeEnum scaleVnfType) {
    this.scaleVnfType = scaleVnfType;
  }

  public ScaleNsRequestScaleVnfData scaleByStepData(ScaleNsRequestScaleVnfDataScaleByStepData scaleByStepData) {
    this.scaleByStepData = scaleByStepData;
    return this;
  }

   /**
   * Get scaleByStepData
   * @return scaleByStepData
  **/
  @Schema(required = true, description = "")
  public ScaleNsRequestScaleVnfDataScaleByStepData getScaleByStepData() {
    return scaleByStepData;
  }

  public void setScaleByStepData(ScaleNsRequestScaleVnfDataScaleByStepData scaleByStepData) {
    this.scaleByStepData = scaleByStepData;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ScaleNsRequestScaleVnfData scaleNsRequestScaleVnfData = (ScaleNsRequestScaleVnfData) o;
    return Objects.equals(this.scaleVnfType, scaleNsRequestScaleVnfData.scaleVnfType) &&
        Objects.equals(this.scaleByStepData, scaleNsRequestScaleVnfData.scaleByStepData);
  }

  @Override
  public int hashCode() {
    return Objects.hash(scaleVnfType, scaleByStepData);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ScaleNsRequestScaleVnfData {\n");
    
    sb.append("    scaleVnfType: ").append(toIndentedString(scaleVnfType)).append("\n");
    sb.append("    scaleByStepData: ").append(toIndentedString(scaleByStepData)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
